#ifndef ANEU_MESHLOADER_H
#define ANEU_MESHLOADER_H

#include <iostream>
#include <unordered_set>
#include <vector>
#include <set>
#include "tools.h"
#include "meshloader.h"

class AneuMeshLoader : public MeshLoader
{
private:
    std::vector<Node> m_nodes;
    std::vector<Element> m_elements;
    std::vector<Surface> m_surfaces;
    Node interpolatedNode(Node& node_1, Node& node_2);

public:
    virtual void loadMesh(char* p) override;
    
    //!!! Эти методы должный быть в базовом классе, т.к. относятся к любому загрузчику
    std::vector<Node>& getNodes();
    std::vector<Element>& getElements();
    std::vector<Surface>& getSurfaces();
    std::vector<Element> findElem(int id_1, int id_2);
    std::vector<Element> findElem(int id_1, int id_2, int id_3);
    void getNodesBySurfaceID(int sur_ID, std::vector<int>& container);
    void getElementsByMatID(int mat_ID, std::vector<Element>& container);
    void getSurfacesByID(int sur_ID, std::vector<Surface>& container);
    void quadrateMeshElements();
    void getNeighbors(std::vector<std::vector<int>>& container);
};

std::ostream& operator<<(std::ostream& stream, AneuMeshLoader& mesh);

#endif