#pragma once

#include<iomanip>
#include<list>
#include<vector>
#include<utility>
#include<algorithm>
#include<set>
#include<unordered_set>
#include"Structure.h"

class MeshLoader
{

public:


	void print() const;
        virtual void LoadMesh(const std::string& P) = 0;

	std::vector<Node>& getNode();
	std::vector<FiniteElement>& getFiniteElement();
	std::vector<BoundaryFiniteElement>& getBoundaryFiniteElement();
        std::vector<Node> getNodeByIdSurface(sizeT Id);

        std::vector<FiniteElement> getFiniteElementById(sizeT Id);
        std::vector <BoundaryFiniteElement> getBoundaryFiniteElementByIdSuface(sizeT Id);
        std::vector<FiniteElement> getFiniteElementByIdNodes(sizeT id1, sizeT id2, sizeT id3);

        std::vector<FiniteElement> getFiniteElementByEdge(sizeT id1, sizeT id2);
        std::vector<std::set<sizeT>>  getNeighboursNodes();

        void InsertMidNodes();
	
protected:

	std::vector<Node> node;
        std::vector<FiniteElement> finelem;
        std::vector<BoundaryFiniteElement> boundelem;
};
